import numpy as np
import matplotlib.pyplot as plt
import csv
import math


bautyp = []
knoten1_pos_x_in_mm = []
knoten1_pos_y_in_mm = []
knoten1_lager_x_in_mm = []
knoten1_lager_y_in_mm = []
knoten2_pos_x_in_mm = []
knoten2_pos_y_in_mm = []    
knoten2_lager_x_in_mm = []
knoten2_lager_y_in_mm = []

id_knoten_neu = []    
knoten_pos_x_in_mm_neu = []
knoten_pos_y_in_mm_neu = []    
knoten_lager_x_in_mm_neu = []
knoten_lager_y_in_mm_neu = []

def knoten_id(pos_x, pos_y):
    returnvalue = 0
    for index in range(len(id_knoten_neu)):
        if (knoten_pos_x_in_mm_neu[index] == pos_x):
            if (knoten_pos_y_in_mm_neu[index] == pos_y):
                returnvalue = index + 1
    return returnvalue

def convert_traglast_app(nummer):
    Datei_App = '../input_csv/inputfile_traglast_'+str(nummer)+'.csv'           # Datei aus App
    Datei_Knoten = '../input_csv/'+str(nummer)+'_Knoten.csv'                    # Datei mit Knoten-ID
    Datei_Lager = '../input_csv/'+str(nummer)+'_Lager.csv'                      # Datei mit Lager
    Datei_Material = '../input_csv/'+str(nummer)+'_Material.csv'                # Datei mit Material
    Datei_Verbindungen = '../input_csv/'+str(nummer)+'_Verbindungen.csv'        # Datei mit Verbindungen
    Datei_Kraefte = '../input_csv/'+str(nummer)+'_Kraefte.csv'                  # Datei mit Kräften
    Datei_sigmaepsilon = '../input_csv/'+str(nummer)+'_sigma_epsilon.csv'        # Datei mit Spannung/Dehung
    
    #Inputfile aus App lesen
    with open(Datei_App,'r') as csvdatei:
        csv_reader_object = csv.reader(csvdatei, delimiter=';')

        zeilennummer = 0
        for row in csv_reader_object:
            if (zeilennummer == 0):
                #Dies ist die erste Zeile in der Datei mit der Spaltenangabe
                zeilennummer += 1
            else:                    
                bautyp.append(int(row[0]))
                knoten1_pos_x_in_mm.append(int(row[1]))
                knoten1_pos_y_in_mm.append(int(row[2]))
                knoten1_lager_x_in_mm.append(int(row[3]))
                knoten1_lager_y_in_mm.append(int(row[4]))
                knoten2_pos_x_in_mm.append(int(row[5]))
                knoten2_pos_y_in_mm.append(int(row[6]))
                knoten2_lager_x_in_mm.append(int(row[7]))
                knoten2_lager_y_in_mm.append(int(row[8]))
                zeilennummer += 1
        
    print(Datei_App + ' eingelesen')
    print(f'Anzahl Datensätze importiert: {zeilennummer-1} \n')    
    print("\n")   
     
    #########################################
    #Datei _Knoten anlegen
    zaehler_id = 1
    for index in range(len(bautyp)):                
        #Ert einmal für Knoten 1
        #testen ob eintrag bereits vorhanden
        kontenposition_bereits_in_liste = False;
        for index_neu in range(len(id_knoten_neu)):                       
            if (knoten1_pos_x_in_mm[index] == knoten_pos_x_in_mm_neu[index_neu]):
                if (knoten1_pos_y_in_mm[index] == knoten_pos_y_in_mm_neu[index_neu]):
                    kontenposition_bereits_in_liste = True
        #wenn noch nicht in liste
        if (kontenposition_bereits_in_liste == False):
            id_knoten_neu.append(zaehler_id)
            knoten_pos_x_in_mm_neu.append(knoten1_pos_x_in_mm[index])
            knoten_pos_y_in_mm_neu.append(knoten1_pos_y_in_mm[index])
            knoten_lager_x_in_mm_neu.append(knoten1_lager_x_in_mm[index])
            knoten_lager_y_in_mm_neu.append(knoten1_lager_y_in_mm[index])
            zaehler_id += 1
        #Dann für Knoten2
        #testen ob eintrag bereits vorhanden
        kontenposition_bereits_in_liste = False;
        for index_neu in range(len(id_knoten_neu)):                       
            if (knoten2_pos_x_in_mm[index] == knoten_pos_x_in_mm_neu[index_neu]):
                if (knoten2_pos_y_in_mm[index] == knoten_pos_y_in_mm_neu[index_neu]):
                    kontenposition_bereits_in_liste = True
        #wenn noch nicht in liste
        if (kontenposition_bereits_in_liste == False):
            id_knoten_neu.append(zaehler_id)
            knoten_pos_x_in_mm_neu.append(knoten2_pos_x_in_mm[index])            
            knoten_pos_y_in_mm_neu.append(knoten2_pos_y_in_mm[index])
            knoten_lager_x_in_mm_neu.append(knoten2_lager_x_in_mm[index])
            knoten_lager_y_in_mm_neu.append(knoten2_lager_y_in_mm[index])
            zaehler_id += 1
                                       
    f = open(Datei_Knoten, "w")
    f.write('Knoten_id_sortiert;x-Koordinate[mm];y-Koordinate[mm]\n')
    for index_neu in range(len(id_knoten_neu)):
        f.write(str(id_knoten_neu[index_neu]) + ';')
        f.write(str(knoten_pos_x_in_mm_neu[index_neu]) + ';')
        f.write(str(knoten_pos_y_in_mm_neu[index_neu]) + '\n')        
    f.close()   
    
    #########################################
    #Datei _Lager anlegen        
    
    f = open(Datei_Lager, "w")
    f.write('Knoten_id_sortiert;x-Koordinate[mm];y-Koordinate[mm]\n')
    for index_neu in range(len(id_knoten_neu)):
        f.write(str(id_knoten_neu[index_neu]) + ';')
        f.write(str(knoten_lager_x_in_mm_neu[index_neu]) + ';')
        f.write(str(knoten_lager_y_in_mm_neu[index_neu]) + '\n')        
    f.close()    
    
    #########################################
    #Datei _Material anlegen        
    
    f = open(Datei_Material, "w")
    f.write('Element_id_sortiert;Material_id\n')
    for index in range(len(bautyp)):
        f.write(str(index+1) + ';')
        f.write(str(bautyp[index]) + '\n')        
    f.close()   
    
    #########################################
    #Datei _Verbindungen anlegen        
    
    f = open(Datei_Verbindungen, "w")
    f.write('Element_id_sortiert;von_Knoten_id;nach_Knoten_id\n')
    for index in range(len(bautyp)):
        f.write(str(index+1) + ';')
        f.write(str(knoten_id(knoten1_pos_x_in_mm[index],knoten1_pos_y_in_mm[index])) + ';')
        f.write(str(knoten_id(knoten2_pos_x_in_mm[index],knoten2_pos_y_in_mm[index])) + '\n')
    f.close()   
    
    #########################################
    #Datei _Kraefte anlegen        
    
    anzahl_der_knoten_fahrbahn = 0
    for index_neu in range(len(id_knoten_neu)):        
        if ((knoten_pos_y_in_mm_neu[index_neu] == 0) and (knoten_lager_y_in_mm_neu[index_neu] == 0)):            
            anzahl_der_knoten_fahrbahn +=1    
    kraft = -10000 / anzahl_der_knoten_fahrbahn
    f = open(Datei_Kraefte, "w")
    f.write('Knoten_id_sortiert;x-Kraft[N];y-Kraft[N]\n')
    for index_neu in range(len(id_knoten_neu)):
        f.write(str(id_knoten_neu[index_neu]) + ';')
        f.write('0;')
        if ((knoten_pos_y_in_mm_neu[index_neu] == 0) and (knoten_lager_y_in_mm_neu[index_neu] == 0)):            
            f.write(str(kraft)+'\n')  
        else:            
            f.write('0\n')  
    f.close() 
    
    #########################################
    #Datei _sigmaepsilon anlegen 
    
    f = open(Datei_sigmaepsilon, "w")
    f.write('Material_id;epsilon;sigma_in_MPa\n')           
    f.write('1;-0.1;-3500.0\n')
    f.write('1;-0.004;-300.0\n')
    f.write('1;-0.000958;-201.0\n')
    f.write('1;0.0;0.0\n')
    f.write('1;0.000958;201.0\n')
    f.write('1;0.004;300.0\n')
    f.write('1;0.1;3500.0\n')
    f.write('2;-0.1;-3500.0\n')
    f.write('2;-0.004;-300.0\n')
    f.write('2;-0.000958;-201.0\n')
    f.write('2;0.0;0.0\n')
    f.write('2;0.000958;201.0\n')
    f.write('2;0.004;300.0\n')
    f.write('2;0.1;3500.0\n')
    f.write('3;-0.1;-3500.0\n')
    f.write('3;-0.004;-300.0\n')
    f.write('3;-0.000958;-201.0\n')
    f.write('3;0.0;0.0\n')
    f.write('3;0.000958;201.0\n')
    f.write('3;0.004;300.0\n')
    f.write('3;0.1;3500.0')
    f.close() 
    
    print('Input-Dateien angelegt')